library jaguar_mux.example.simple.client;

import 'dart:async';
import 'dart:convert';

import 'package:http/http.dart' as http;

const String kHostname = 'localhost';

const int kPort = 8080;

final http.Client _client = new http.Client();

Future<Null> printHttpClientResponse(http.Response resp) async {
  print('=========================');
  print("body:");
  print(resp.body);
  print("statusCode:");
  print(resp.statusCode);
  print("headers:");
  print(resp.headers);
  print('=========================');
}

Future<Null> execGetUser() async {
  String url = "http://$kHostname:$kPort/user/1";
  http.Response resp = await _client.get(url);

  printHttpClientResponse(resp);
}

Future<Null> execVersion() async {
  String url = "http://$kHostname:$kPort/version";
  http.Response resp = await _client.get(url);

  printHttpClientResponse(resp);
}

Future<Null> execGetQueryParams() async {
  String url =
      "http://$kHostname:$kPort/query/params?name=teja&password=secret";
  http.Response resp = await _client.get(url, headers: {'hello': 'jaguar'});

  printHttpClientResponse(resp);
}

Future<Null> execWrapEncodeMapToJson() async {
  String url = "http://$kHostname:$kPort/encode/maptojson";
  http.Response resp = await _client.get(url);

  printHttpClientResponse(resp);
}

Future<Null> execWrapSimpleInterceptor() async {
  String url = "http://$kHostname:$kPort/wrap/simpleinterceptor";
  http.Response resp = await _client.get(url);

  printHttpClientResponse(resp);
}

Future<Null> execDecodeJsonMap() async {
  String url = "http://$kHostname:$kPort/decode/json/map";
  http.Response resp =
      await _client.post(url, body: JSON.encode({"data": 5, "data1": 55}));

  printHttpClientResponse(resp);
}

main() async {
  await execGetUser();
  await execVersion();
  await execGetQueryParams();
  await execWrapEncodeMapToJson();
  await execWrapSimpleInterceptor();
  await execDecodeJsonMap();
}
