library jaguar_mux.mux;

import 'dart:async';
import 'package:jaguar/jaguar.dart' as j;
import 'package:jaguar_mux/jaguar_mux.dart';

import 'package:jaguar_reflect/jaguar_reflect.dart';

class Mux implements j.RequestHandler {
  final List<ReflectedRoute> _routes;

  Mux._(this._routes);

  Future<j.Response> handleRequest(j.Request request, {String prefix}) async {
    for (ReflectedRoute route in _routes) {
      j.Response response = await route.handleRequest(request, prefix: prefix);
      if (response is j.Response) {
        return response;
      }
    }

    return null;
  }

  factory Mux.build(MuxBuilder builder) {
    final List<ReflectedRoute> routes = [];
    for (Route route in builder.routes) {
      j.Route jRoute = new j.Route(
          path: route.path, methods: route.methods, pathRegEx: route.pathRegEx);
      routes.add(new ReflectedRoute.build(
          route.handler, jRoute, '', route.interceptors));
    }
    return new Mux._(routes);
  }
}
