part of jaguar_mux.jaguar_mux;

class Route {
  final String path;

  final List<String> methods;

  final Map<String, String> pathRegEx;

  final Function handler;

  Route(this.path, this.handler,
      {this.methods: const <String>['GET', 'PUT', 'POST', 'DELETE'],
      this.pathRegEx});

  Route.Get(this.path, this.handler, {this.pathRegEx}) : methods = ['GET'];

  Route.Post(this.path, this.handler, {this.pathRegEx}) : methods = ['POST'];

  Route.Put(this.path, this.handler, {this.pathRegEx}) : methods = ['PUT'];

  Route.Delete(this.path, this.handler, {this.pathRegEx})
      : methods = ['DELETE'];

  final List<RouteWrapper> interceptors = <RouteWrapper>[];

  Route wrap(RouteWrapper interceptor) {
    if (interceptor == null) return this;
    interceptors.add(interceptor);
    return this;
  }

  Route wrapAll(List<RouteWrapper> interceptors) {
    for (RouteWrapper wrapper in interceptors) {
      wrap(wrapper);
    }
    return this;
  }

  void _wrapAllAtBeginning(List<RouteWrapper> interceptors) {
    for (RouteWrapper wrapper in interceptors.reversed) {
      this.interceptors.insert(0, wrapper);
    }
  }
}
